# coding=gbk

import urllib,sys,os
from BeautifulSoup import BeautifulSoup

from PyQt4 import QtGui,QtCore
from tuangou_ui import Ui_mainWidget
import tuangou_rc

class MyTuanGou(QtGui.QWidget):
    def __init__(self,parent = None):
        super(MyTuanGou,self).__init__(parent)
        self.ui = Ui_mainWidget()
        self.ui.setupUi(self)
        self.webList = {u'':'meituan',u'Ŵ':'nuomituan',u'QQŹ':'qqtuan'}

        self.ui.listCombo.addItem(u'--ѡ--')
        self.ui.listCombo.addItems(self.webList.keys())
        self.ui.listCombo.currentIndexChanged.connect(self.process)

        self.ui.titleLabel.setWordWrap(True)

        self.prefix = os.path.abspath('.') + os.sep + 'tuanPic'
        if not os.path.exists(self.prefix):
            for name in self.webList.values():
                os.makedirs(self.prefix + os.sep + name)
        else:
            for name in self.webList.values():
                if not os.path.exists(self.prefix + os.sep + name):
                    os.mkdir(self.prefix + os.sep + name)


    def process(self,index):
        text = unicode(self.ui.listCombo.itemText(index).toUtf8(),'utf8','ignore')
        if text == u'--ѡ--':
            self.clear()
        else:
            self.web_name = self.webList[text]
            exec('self.%s()' % self.web_name)


    def meituan(self):
        url = 'http://www.meituan.com/shanghai'
        html = urllib.urlopen(url)
        parser = BeautifulSoup(html)
        h_tag = parser.find('h1')
        self.title = ''
        if h_tag.a:
            h_tag.a.extract()
        for x in h_tag.contents:
            self.title = self.title + x.string
        self.price = ''
        price_str = parser.find('p','deal-price').contents[0].string
        for x in price_str:
            if x.isdigit():
                self.price = self.price + x
        img_tag = parser.find('div','deal-buy-cover-img').img
        self.pic = img_tag['src']

        self.showAll()

    def qqtuan(self):
        url = 'http://tuan.qq.com/shanghai'
        html = urllib.urlopen(url)
        parser = BeautifulSoup(html)
        h_tag = parser.find('div','hd').h3
        self.title = ''
        if h_tag.a:
            h_tag.a.extract()
        for x in h_tag.contents:
            self.title = self.title + x.string
        self.price = ''
        price_str = parser.find('p','current_price').span.string
        for x in price_str:
            if x.isdigit():
                self.price = self.price + x
        img_tag = parser.find('div','photo').img
        self.pic = img_tag['src']

        self.showAll()
        
    def nuomituan(self):
        url = 'http://www.nuomi.com/shanghai'
        html = urllib.urlopen(url)
        parser = BeautifulSoup(html)
        self.title = parser.find('h1').contents[0]
        self.price = parser.find('p','cur-price').contents[1]
        img_tag = parser.find('div','product-pic').img
        self.pic = img_tag['src']

        self.showAll()

    def showAll(self):
        file_name = ''
        for x in reversed(self.pic):
            if x == '/':
                break
            else:
                file_name = x + file_name
        self.image = self.prefix + os.sep + self.web_name + os.sep + file_name
        if not os.path.exists(self.image):
            urllib.urlretrieve(self.pic,self.image)

        self.ui.titleLabel.setText(u'<font size="4">' + u'<b>Ź:</b>' + self.title + u'</font>')
        self.ui.priceLabel.setText(u'<font size="4">' + u'<b>Ź:</b>' + self.price + u'Ԫ' + u'</font>')
        self.ui.imgLabel.setPixmap(QtGui.QPixmap(self.image))

    def clear(self):
        self.ui.titleLabel.clear()
        self.ui.priceLabel.clear()
        self.ui.imgLabel.clear()

if __name__=='__main__':

    app = QtGui.QApplication(sys.argv)
    tuangou = MyTuanGou()
    tuangou.setFixedSize(tuangou.size())
    tuangou.setWindowIcon(QtGui.QIcon(':/sun.png'))
    tuangou.show()
    sys.exit(app.exec_())